
########################################
# KREIRANJE VEKTORA I MATRICA
########################################

b<-c(1,2,3,4)
1/b

b1<-c(b,0,b)
b1

b+1
b+c(2,1)    # = (1,2,3,4)+(2,1,2,1)

length(b)

d1<-1:5
d1
range(d1)
sin(d1)

d2<-5:1
d2

d3<-seq(5,1,by=-.2)    # kreira vektor (5, 4.8, 4.6, ... 1.2, 1)
d3


######################### 

v<-numeric()
v[3]<-10
v

#########################

# matrice

B <- matrix(c(2, 4, 3, 1, 5, 7), nrow=3, ncol=2) 
B

C <- matrix( c(7, 4, 2), nrow=3, ncol=1)
C


### KREIRANJE MATRICA POMOCU FINKCIJA cbind() i rbind() ###

A<-cbind(B, C)   # matrica A dobivena je kombiniranjem stupaca B i C matrice
A

D <- matrix( c(6, 2), nrow=1, ncol=2)
A1 <- rbind(B,D)  # matrica A dobivena je kombiniranjem redova matrica B i D
                  # i to tako da je matrica D "stavljena ispod"" matrice B
A1

####

A<-matrix(c(1, 2, 3, 4, 5, 6, 7, 8, 9),nrow=3,byrow=TRUE)
A

A<-matrix(1:9,nrow=3,byrow=TRUE)   # slaze elemente po redovima
A
A1<-matrix(1:9,nrow=3)             # slaze elemente po stupcima
A1

# length(A)
length(A)

B<-matrix(0,4,4)
B

C<-diag(5)      # jedinicna matrica
C

M<-array(1:20,dim=c(4,5))
M


z<-c(1,2,3,4,5,6,7,8,9,10,11,12)
dim(z)<-c(3,4)
z
dim(z)

dim(z)<-c(6,2)
z
dim(z)
t(z)           # transponirana matrica
  
########################################################
# indeksiranje i odabiranje elemenata vektora/matrica
########################################################

d<-c(1,4,3,5,2)
d
d[c(2,4)]             # odabiranje drugog i cetvrtog elementa vektora d4
d[c(2,4,2,4,1)]
d[c(-2,-4)]      # odabire sve elemente vektora d4 osim drugog i cetvrtog elementa
d[c(TRUE,FALSE,FALSE,TRUE,FALSE)]   # odabire prvi i cetvrti element vektors d4
d[d>2]     # odabire sve elemente vektora d4 koji su veci od 2


######

A<-matrix(1:9,nrow=3,byrow=TRUE)   

A
A[1,2]
A[1,]
A[,2]

nrow(A)    # daje broj redaka matrice
ncol(A)    # daje broj stupaca matrice

#####



########################################
#  OSNOVNE OPERACIJE MATRICNE ALGEBRE
########################################

A <- matrix(c(1+1i,2-3i,3,4-1i,5,6),nrow=2,byrow=TRUE)
A
t(A)    # transponirana matrica
Conj(A)  # konjugirana matrica


a = c(1, 3, 5, 7) 
b = c(1, 2, 4, 8)

a+b
a-b
2*a     # mnozenje vektora za skalarom
a * b   # mnozenje "element po element"
a / b   # djeljenje "element po element"

# mnozenje matrica
# za mnozenje matrica koristi se operator %*%

M<-matrix(c(1,2,3,4,5,6),nrow=2,byrow=TRUE)
M

v<-c(1,1,1)
v

M%*%v

##############

A<-matrix(1:9,nrow=3,byrow=TRUE)
B<-matrix(1:9,nrow=3)

A*B     # matrica produkta element po element

A%*%B   # produkt matrice A i B  

v<-c(1,1,1)
v%*%A     # vektor v se tretira kao vektor redak
A%*%v     # vektor v se tretira kao vektor stupac

v%*%A%*%v    # kvadratna forma

################
# pitanje: kako pomnozoti (v * v^t) gdje je v vektor stupac ? (sa v^t oznacili smo transponirani vektor v)
v<-c(1,1,1)
v%*%v                 # daje skalarnu vrijednost  (nije ono sto zelimo)
t(v)%*%v              # daje skalarnu vrijednost  (nije ono sto zelimo)
crossprod(v,v)        # daje skalarnu vrijednost  (nije ono sto zelimo)

v
cbind(v)

cbind(v)%*%v   # rjesenje ! (dobili smo matricu v * v^t)

v
rbind(v)

v%*%rbind(v)   # alternativno rjesenje

# jos jedno rjesenje:
v1<-v
dim(v1)<-c(3,1)     # definiramo vektor v tako da je njegova dimenzija 3 x 1, tj. stupac vektor
v
v1
v1%*%v


#############################################
# SKALARNI PRODUKT
#############################################

v<-c(1,2,3)
w<-c(-1,0,1)

sum(v*w)   # daje sakalarni produkt vektora v i w

# za vektorski produkt ne postoji direktna naredba u R-u

#############################################
# SUSTAVI LINEARNIH JEDNADZBI
#############################################

# rjesenje sustava Ax=b po gdje se trazi x uz zadane A i b: solve(A,b)

### PRIMJER 1 ###
A<-matrix(c(-2,3,1,2,2,-1,1,3,2),nrow=3,byrow=TRUE)
b<-c(1,2,3)
solve(A,b)

# solve(A) daje inverznu matricu matrica A
solve(A)%*%b


### PRIMJER 2 ###
A<-matrix(c(3,2,1,7,6,5,5,4,3),nrow=3,byrow=TRUE) # Rang matrice A je 2
b<-c(-1,2,2)    # vektor b se ne nalazi u slici od A
solve(A,b)      # R javlja da je "system computationally singular"
solve(A)        # inverz ne postoji


### PRIMJER 3 ###
# NAPOMENA: solve radi samo za kvadratnim matricama A (za razliku oeratora "\" iz matlaba)
A<-matrix(c(2,-1,1,10,1,2),nrow=3,byrow=TRUE)
b<-c(1,1,1)
solve(A,b)   # R javlja gresku. sustav je "overdetermined"

################################################
# RANG MATRICE
################################################

A<-matrix(c(1,2,3,3,2,1,4,4,4),nrow=3,byrow=TRUE)
A

qr(A)$rank

################################################
# DETERMINANTA I TRAG MATRICE
################################################

A<-matrix(c(1,2,3,3,2,1,4,4,4),nrow=3,byrow=TRUE)
A
det(A)   # =0.  sto to znaci?

solve(A)

# u R-u ne postoji direktna naradba za racunanje traga.
# za racunanje traga matrice M koristi se sum(diag(M))

sum(diag(A))

################################################
# VEKTORSKE I MATRICNE NORME
################################################

# VEKTORSKE NORME
# napomena: za vektore R nema direktnu "norm" 
# funkciju (samo za matrice)
# vektorske norme mogu se racunati na sljedece nacine

v <- c(1,2,3)
norm(matrix(v),'1')    # 1-norma
norm(matrix(v),'i')    # beskonacno-norma

# racunanje proizvoljne p-norme: sum(abs(v)^p)^(1/p)

sum(abs(v)^2)^(1/2)    # 2-norma

# MATRICNE NORME

A<-matrix(c(1,4,-2,3,2,5,-2,-4,2),nrow=3,byrow=TRUE)

norm(A,'1')    # 1-norma
max(svd(A)$d)  # 2-norma (=max singularna vrijednost)
norm(A,'i')    # beskonacno-norma

################################################
# SVOJSTVENE VRIJEDNOSTI I SVOJSTVENI VEKTORI
################################################

# Funkcije eigen(M) recuna svojstvene vrijednosti i
# svojstvene vektore matrice M. Rezultat ove funkcije 
# je lista s dvije komponente koje sadrze svojstvene
# vrijednosti (values) i svojstvene vektore (vectors)

### PRIMJER 1 ###
M<-matrix(c(1,4,-2,3,2,5,-2,-4,2),nrow=3,byrow=TRUE)
M

ev<-eigen(M)
ev

evals<-eigen(M)$values
evals

evect<-eigen(M)$vectors
evect

v1<-evect[,1]   # izbaremo prvi svojestveni vektor (prvi STUPAC iz matrice evect1)
v2<-evect[,2]   # izbaremo drugi svojestveni vektor
v3<-evect[,3]   # izbaremo treci svojestveni vektor

M%*%v1
evals[1]*v1

M%*%v2
evals[2]*v2

M%*%v3
evals[3]*v3


### PRIMJER 2 ###
# svojstvene vrijednost pozitivno (semi)definitne matrice su nenegativne
M<-matrix(c(1,4,-2,3,2,5,-2,-4,2),nrow=3,byrow=TRUE)
M1=t(M)%*%M     # M1 je nuzno pozitivno (semi)definitne matrica
ev1<-eigen(M1)
ev1

# svojestveni vektori pozitivno (semi)definitne matrice su medjusobno ortogonalni
evect1<-eigen(M1)$vectors
e1<-evect1[,1]   # izbaremo prvi svojestveni vektor (prvi STUPAC iz matrice evect1)
e2<-evect1[,2]   # izbaremo drugi svojestveni vektor
e3<-evect1[,3]   # izbaremo treci svojestveni vektor

e1%*%e2    # vektori e1 i e2 su ortogonalni
e1%*%e3    # vektori e1 i e3 su ortogonalni
e2%*%e3    # vektori e2 i e3 su ortogonalni



########################################
# SINGULARNE VRIJEDNOSTI 
########################################

# Funkcija svd(M) uzima kao argument matricu M i racuna
# njenu singularnu dekompoziciju.

M<-matrix(c(1,2,3,4,5,6,7,8),nrow=4,byrow=TRUE)
M

s<-svd(M)
s$u
s$d
s$v

D<-diag(s$d)

s$u %*% D %*% t(s$v)      # M=U D V'
t(s$u) %*% M %*% s$v      #  D = U' M V











